# Initialize a string that will contain the math operations to perform
set math ""

# Initialize a position counter for the widgets being created.

set pos 0

# Loop through the numbers and operations creating buttons for each widget


foreach val {1 2 3 4 5 6 7 8 9 + 0 - * / } {

    # Create a button
    # The button names are .b0, .b1, .b2, etc.
    # The text to display is the current item in the list
    # The action for the button is to append that value onto the math string.

    button .b$pos -text $val -command "append math $val"

    # The buttons are displayed in a 3 column wide grid.
    # Calculate the row and column

    set row [expr ($pos) / 3]
    set col [expr ($pos) % 3]
    
    # And map the widget to the screen

    grid .b$pos -row $row -col $col 
    
    # Increment the position/name counter

    incr pos
}

# The equals button has a different command.
# When the equal button is clicked, it will evaluate the math expression,
# and assign the output to the result variable.  
# It then clears the math expression for the next set of calculations.

button .b_eq -text "=" -command {set result [expr $math]; set math ""}
grid .b_eq -row 4 -col 2

# Create two labels to display the math expression and result.

label .math -textvariable math
grid .math -row 5 -column 0 -columnspan 3

label .result -textvariable result
grid .result -row 6 -column 0 -columnspan 3

